SystemOrganization addCategory: #'Javascript-Core-Decorations'!
SystemOrganization addCategory: #'Javascript-Core-Object'!
SystemOrganization addCategory: #'Javascript-Core-Parser'!

!WAUrl methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:06'!
javascriptOn: aStream 
	aStream javascript: self printString! !

WAObject subclass: #JSDecoration
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSDecoration commentStamp: 'lr 4/28/2008 09:47' prior: 0!
I decorate JavaScript objects.!

JSDecoration subclass: #JSApply
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSApply commentStamp: 'lr 4/28/2008 09:47' prior: 0!
I apply a JavaScript function and provide arguments.!

!JSApply methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:49'!
arguments
	^ arguments! !

!JSApply methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:49'!
arguments: aCollection
	arguments := aCollection! !

!JSApply methodsFor: 'printing' stamp: 'lr 4/7/2009 16:47'!
printContentOn: aStream
	super printContentOn: aStream.
	JSStream encodeArguments: self arguments on: aStream! !

JSDecoration subclass: #JSAssignment
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssignment commentStamp: 'lr 4/28/2008 09:48' prior: 0!
I represent an assignment ot the decorated object.!

!JSAssignment methodsFor: 'accessing' stamp: 'lr 7/4/2007 07:43'!
object
	^ object! !

!JSAssignment methodsFor: 'accessing' stamp: 'lr 7/4/2007 07:44'!
object: anObject
	object := anObject! !

!JSAssignment methodsFor: 'printing' stamp: 'lr 10/28/2007 14:40'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPutAll: '='; javascript: self object! !

JSDecoration subclass: #JSCall
	instanceVariableNames: 'name arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSCall methodsFor: 'accessing' stamp: 'lr 4/7/2009 16:48'!
arguments
	^ arguments! !

!JSCall methodsFor: 'accessing' stamp: 'lr 4/7/2009 16:48'!
arguments: anArray 
	arguments := anArray! !

!JSCall methodsFor: 'accessing' stamp: 'lr 4/7/2009 16:48'!
name
	^ name! !

!JSCall methodsFor: 'accessing' stamp: 'lr 4/7/2009 16:48'!
name: aString 
	name := aString! !

!JSCall methodsFor: 'printing' stamp: 'lr 9/22/2009 10:07'!
printContentOn: aStream
	super printContentOn: aStream.
	(self name isNil or: [ self name isEmpty ])
		ifFalse: [ aStream nextPut: $.; nextPutAll: self name ].
	JSStream encodeArguments: self arguments on: aStream! !

JSDecoration subclass: #JSCreate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSCreate commentStamp: 'lr 4/28/2008 09:48' prior: 0!
I instantiate the decorated object.!

!JSCreate methodsFor: 'printing' stamp: 'lr 5/10/2006 08:39'!
printContentOn: aStream
	aStream nextPutAll: 'new '.
	super printContentOn: aStream! !

!JSDecoration methodsFor: 'testing' stamp: 'lr 12/4/2008 22:31'!
isJavascript
	^ true! !

!JSDecoration methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:09'!
owner
	^ owner! !

!JSDecoration methodsFor: 'printing' stamp: 'lr 5/9/2006 20:34'!
printContentOn: aStream
	self owner printContentOn: aStream! !

!JSDecoration methodsFor: 'accessing' stamp: 'jf 7/19/2009 15:00'!
renderContext
	^ owner renderContext! !

!JSDecoration methodsFor: 'initialization' stamp: 'lr 11/17/2008 20:15'!
setOwner: anObject
	owner := anObject! !

JSDecoration subclass: #JSIfThenElse
	instanceVariableNames: 'trueStatement falseStatement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSIfThenElse commentStamp: 'lr 4/28/2008 09:50' prior: 0!
I execute different code snippets depending if the receiver is true (defined) or false (null).!

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
falseStatement
	^ falseStatement! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
falseStatement: anObject
	falseStatement := anObject! !

!JSIfThenElse methodsFor: 'printing' stamp: 'lr 8/8/2007 14:17'!
printContentOn: aStream
	aStream nextPut: $(.
	super printContentOn: aStream.
	aStream nextPut: $?.
	aStream javascript: self trueStatement.
	aStream nextPut: $:.
	aStream javascript: self falseStatement.
	aStream nextPut: $)! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
trueStatement
	^ trueStatement! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
trueStatement: anObject
	trueStatement := anObject! !

JSDecoration subclass: #JSMember
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSMember subclass: #JSAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAccess commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I access a member of the decorated object.!

!JSAccess methodsFor: 'printing' stamp: 'lr 5/9/2006 20:48'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPut: $.; nextPutAll: self name! !

JSMember subclass: #JSAlias
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAlias commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I alias the decorated object with a name.!

!JSAlias methodsFor: 'printing' stamp: 'lr 5/18/2006 08:22'!
printContentOn: aStream
	aStream nextPutAll: self name! !

JSMember subclass: #JSAssign
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssign commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I assign the decorated object to a global variable.!

!JSAssign methodsFor: 'printing' stamp: 'lr 7/6/2006 16:27'!
printContentOn: aStream
	aStream nextPutAll: self name; nextPut: $=.
	super printContentOn: aStream! !

JSAssign subclass: #JSAssignLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssignLocal commentStamp: 'lr 4/28/2008 09:52' prior: 0!
I assign the decorated object to a local variable.!

!JSAssignLocal methodsFor: 'printing' stamp: 'lr 7/6/2006 16:28'!
printContentOn: aStream
	aStream nextPutAll: 'var '.
	super printContentOn: aStream! !

!JSMember class methodsFor: 'instance creation' stamp: 'lr 10/13/2008 21:42'!
named: anObject
	^ self new name: anObject! !

!JSMember methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:46'!
name
	^ name! !

!JSMember methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:46'!
name: aString
	name := aString! !

JSMember subclass: #JSProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSProperty commentStamp: 'lr 4/28/2008 09:52' prior: 0!
I access a property of the decoarated object.!

!JSProperty methodsFor: 'printing' stamp: 'lr 5/9/2006 20:48'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPut: $[; javascript: self name; nextPut: $]! !

JSDecoration subclass: #JSNegation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSNegation commentStamp: 'lr 4/28/2008 09:52' prior: 0!
I negate the decorated object and yield a boolean value.!

!JSNegation methodsFor: 'printing' stamp: 'lr 1/4/2007 17:37'!
printContentOn: aStream
	aStream nextPut: $!!.
	super printContentOn: aStream! !

JSDecoration subclass: #JSStatement
	instanceVariableNames: 'statement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSStatement subclass: #JSBinary
	instanceVariableNames: 'operator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSBinary commentStamp: 'lr 4/28/2008 09:54' prior: 0!
I join the decorated object with a binary operator.!

!JSBinary methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:22'!
operator
	^ operator! !

!JSBinary methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:22'!
operator: aString
	operator := aString! !

!JSBinary methodsFor: 'printing' stamp: 'lr 7/10/2007 10:23'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPutAll: self operator; javascript: self statement! !

JSStatement subclass: #JSConcatenation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSConcatenation methodsFor: 'printing' stamp: 'lr 10/14/2008 12:20'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPut: $;; javascript: self statement! !

JSStatement subclass: #JSCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSCondition commentStamp: 'lr 4/28/2008 09:53' prior: 0!
I wrap the decorated object into a conditional statement.!

!JSCondition methodsFor: 'printing' stamp: 'lr 5/9/2006 20:29'!
printContentOn: aStream
	aStream nextPutAll: 'if('; javascript: self statement; nextPutAll: '){'.
	super printContentOn: aStream.
	aStream nextPut: $}! !

!JSStatement class methodsFor: 'instance creation' stamp: 'lr 5/9/2006 20:19'!
on: anObject
	^ self new statement: anObject! !

!JSStatement methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:14'!
statement
	^ statement! !

!JSStatement methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:14'!
statement: anObject
	statement := anObject! !

JSDecoration subclass: #JSTimed
	instanceVariableNames: 'duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSTimed subclass: #JSInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSInterval commentStamp: 'lr 10/13/2008 21:46' prior: 0!
I periodically execute the decorated object.!

!JSInterval methodsFor: 'printing' stamp: 'lr 10/13/2008 21:39'!
printContentOn: aStream
	aStream nextPutAll: 'setInterval(function(){'.
	super printContentOn: aStream.
	aStream nextPutAll: '},'; javascript: self duration; nextPut: $)! !

!JSTimed class methodsFor: 'instance creation' stamp: 'lr 10/13/2008 21:45'!
duration: aDuration
	^ self new duration: aDuration! !

!JSTimed methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:39'!
duration
	^ duration! !

!JSTimed methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:39'!
duration: aDuration
	duration := aDuration! !

JSTimed subclass: #JSTimeout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSTimeout commentStamp: 'lr 4/28/2008 09:54' prior: 0!
I evaluate the decorated object after a timeout.!

!JSTimeout methodsFor: 'printing' stamp: 'lr 4/17/2007 14:29'!
printContentOn: aStream
	aStream nextPutAll: 'setTimeout(function(){'.
	super printContentOn: aStream.
	aStream nextPutAll: '},'; javascript: self duration; nextPut: $)! !

WAObject subclass: #JSJoin
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSJoin commentStamp: 'lr 4/28/2008 09:46' prior: 0!
I join a collection of JavaScript statements with the given string.!

!JSJoin class methodsFor: 'instance creation' stamp: 'lr 10/16/2008 19:19'!
new
	^ self on: OrderedCollection new! !

!JSJoin class methodsFor: 'instance creation' stamp: 'lr 10/16/2008 19:19'!
on: aCollection
	^ self basicNew initializeOn: aCollection! !

!JSJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:40'!
collection
	^ collection! !

!JSJoin methodsFor: 'initialization' stamp: 'jf 3/13/2009 17:59'!
initializeOn: aCollection
	self initialize.
	collection := aCollection! !

!JSJoin methodsFor: 'printing' stamp: 'lr 4/26/2009 16:33'!
printElement: anObject on: aStream
	anObject isVariableBinding
		ifFalse: [ aStream javascript: anObject ]
		ifTrue: [
			aStream nextPut: $"; nextPutAll: anObject key seasideString.
			anObject key isNil
				ifTrue: [ aStream nextPut: $" ]
				ifFalse: [
					aStream nextPut: $=.
					anObject value isString
						ifTrue: [ aStream nextPutAll: anObject value; nextPut: $" ]
						ifFalse: [ aStream nextPut: $"; nextPut: $+; javascript: anObject value ] ] ]! !

!JSJoin methodsFor: 'printing' stamp: 'lr 10/16/2008 19:41'!
printEmptyOn: aStream
	aStream nextPutAll: '""'! !

!JSJoin methodsFor: 'printing' stamp: 'lr 10/16/2008 19:45'!
printOn: aStream
	self collection isEmpty
		ifTrue: [ ^ self printEmptyOn: aStream ].
	self collection size = 1
		ifTrue: [ ^ self printElement: self collection first on: aStream ].
	aStream nextPut: $[.
	self collection 
		do: [ :each | self printElement: each on: aStream ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPutAll: '].join("&")'! !

WAObject subclass: #JSJsonParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Parser'!

!JSJsonParser commentStamp: 'pmm 12/15/2008 20:08' prior: 0!
A JSJsonParser is a parser that parses JSON. It is a bit more forgiving than the standard and allows any kind of top level element except numbers, not just {} and [].

http://json.org/
http://tools.ietf.org/html/rfc4627
!

!JSJsonParser class methodsFor: 'instance creation' stamp: 'lr 6/25/2009 15:58'!
new
	self error: 'Instantiate the parser with a stream.'! !

!JSJsonParser class methodsFor: 'instance creation' stamp: 'lr 6/25/2009 15:57'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!JSJsonParser class methodsFor: 'accessing' stamp: 'lr 6/25/2009 15:55'!
parse: aString
	^ self parseStream: aString readStream! !

!JSJsonParser class methodsFor: 'accessing' stamp: 'lr 6/25/2009 15:57'!
parseStream: aStream
	^ (self on: aStream) parse! !

!JSJsonParser methodsFor: 'adding' stamp: 'lr 6/25/2009 20:06'!
addProperty: anAssociation to: anObject
	"Add the property anAssociation described with key and value to anObject. Subclasses might want to refine this implementation."
	
	^ anObject 
		add: anAssociation;
		yourself! !

!JSJsonParser methodsFor: 'adding' stamp: 'lr 6/25/2009 20:06'!
addValue: anObject to: aCollection
	"Add anObject to aCollection. 	Subclasses might want to refine this implementation."

	^ aCollection copyWith: anObject! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 6/25/2009 20:06'!
createArray
	"Create an empty collection. Subclasses might want to refine this implementation."

	^ Array new! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createFalse
	"Create the false literal. Subclasses might want to refine this implementation."
	
	^ false! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createNull
	"Create the null literal. Subclasses might want to refine this implementation."

	^ nil! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createNumber: aString
	"Create a number literal. Subclasses might want to refine this implementation."

	^ aString asNumber! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 6/25/2009 16:53'!
createObject
	"Create an empty object. Subclasses might want to refine this implementation."
	
	^ Dictionary new! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:55'!
createProperty: aKey with: aValue
	"Create an empty attribute value pair. Subclasses might want to refine this implementation."
	
	^ aKey -> aValue! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createString: aString
	"Create a string literal. Subclasses might want to refine this implementation."

	^ aString! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:55'!
createTrue
	"Create the true literal. Subclasses might want to refine this implementation."

	^ true! !

!JSJsonParser methodsFor: 'private' stamp: 'lr 6/25/2009 16:09'!
error: aString
	"Raise a parse error labelled aString."

	^ JSJsonSyntaxError signal: aString! !

!JSJsonParser methodsFor: 'private' stamp: 'lr 6/29/2009 14:28'!
expect: aString
	"Expects aString and consume input, throw an error otherwise."

	^ (self match: aString) ifFalse: [ self error: aString , ' expected' ]! !

!JSJsonParser methodsFor: 'initialization' stamp: 'lr 6/25/2009 21:15'!
initializeOn: aStream
	stream := aStream! !

!JSJsonParser methodsFor: 'private' stamp: 'jok 7/16/2009 15:29'!
match: aString
	"Tries to match aString, consume input and answer true if successful."
	
	| position |
	position := stream position.
	aString do: [ :each |
		(stream atEnd or: [ stream next ~= each ]) ifTrue: [ 
			stream position: position.
			^ false ] ].
	self whitespace.
	^ true! !

!JSJsonParser methodsFor: 'parsing' stamp: 'lr 6/25/2009 23:00'!
parse
	| result |
	result := self whitespace; parseValue.
	stream atEnd
		ifFalse: [ self error: 'end of input expected' ].
	^ result! !

!JSJsonParser methodsFor: 'parsing' stamp: 'lr 9/8/2009 19:45'!
parseArray
	| result |
	self expect: '['.
	result := self createArray.
	(self match: ']')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addValue: self parseValue
			to: result.
		(self match: ']') 
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of array expected'! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/29/2009 14:39'!
parseCharacter
	| char |
	(char := stream next) = $\ 
		ifFalse: [ ^ char ].
	(char := stream next) = $" 
		ifTrue: [ ^ char ].
	char = $\
		ifTrue: [ ^ char ].
	char = $/
		ifTrue: [ ^ char ].
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 7/16/2009 08:52'!
parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/29/2009 14:39'!
parseCharacterHexDigit
	| digit |
	stream atEnd ifFalse: [
		digit := stream next seasideInteger.
		(digit between: 48 "$0" and: 57 "$9")
			ifTrue: [ ^ digit - 48 ].
		(digit between: 65 "$A" and:  70 "$F")
			ifTrue: [ ^ digit - 55 ].
		(digit between: 97 "$a" and: 102 "$f")
			ifTrue: [ ^ digit - 87 ] ].
	self error: 'hex-digit expected'! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/25/2009 23:17'!
parseNumber
	| negated number |
	negated := stream peek = $-.
	negated ifTrue: [ stream next ].
	number := self parseNumberInteger.
	(stream peek = $.) ifTrue: [
		stream next. 
		number := number + self parseNumberFraction ].
	(stream peek = $e or: [ stream peek = $E ]) ifTrue: [
		stream next.
		number := number * self parseNumberExponent ].
	negated ifTrue: [ number := number negated ].
	^ self whitespace; createNumber: number! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/25/2009 23:04'!
parseNumberExponent
	| number negated |
	number := 0.
	negated := stream peek = $-.
	(negated or: [ stream peek = $+ ])
		ifTrue: [ stream next ].
	[ stream atEnd not and: [ stream peek isDigit ] ]
		whileTrue: [ number := 10 * number + (stream next seasideInteger - 48) ].
	negated
		ifTrue: [ number := number negated ].
	^ 10 raisedTo: number! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/25/2009 23:12'!
parseNumberFraction
	| number power |
	number := 0. power := 1.0.
	[ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [ 
		number := 10 * number + (stream next seasideInteger - 48).
		power := power * 10.0 ].
	^ number / power! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/25/2009 23:13'!
parseNumberInteger
	| number |
	number := 0.
	[ stream atEnd not and: [ stream peek isDigit ] ]
		whileTrue: [ number := 10 * number + (stream next seasideInteger - 48) ].
	^ number! !

!JSJsonParser methodsFor: 'parsing' stamp: 'lr 9/8/2009 19:44'!
parseObject
	| result |
	self expect: '{'.
	result := self createObject.
	(self match: '}')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addProperty: self parseProperty
			to: result.
		(self match: '}')
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of object expected'! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/25/2009 23:35'!
parseProperty
	| name value |
	name := self parseString.
	self expect: ':'.
	value := self parseValue.
	^ self createProperty: name with: value.! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/29/2009 14:40'!
parseString
	| result |
	self expect: '"'.
	result := WriteStream on: String new.
	[ stream atEnd or: [ stream peek = $" ] ] 
		whileFalse: [ result nextPut: self parseCharacter ].
	^ self expect: '"'; createString: result contents! !

!JSJsonParser methodsFor: 'parsing' stamp: 'lr 6/29/2009 14:39'!
parseValue
	| char |
	stream atEnd ifFalse: [ 
		char := stream peek.
		char = ${
			ifTrue: [ ^ self parseObject ].
		char = $[
			ifTrue: [ ^ self parseArray ].
		char = $"
			ifTrue: [ ^ self parseString ].
		(char = $- or: [ char between: $0 and: $9 ])
			ifTrue: [ ^ self parseNumber ].
		(self match: 'true')
			ifTrue: [ ^ self createTrue ].
		(self match: 'false')
			ifTrue: [ ^ self createFalse ].
		(self match: 'null')
			ifTrue: [ ^ self createNull ] ].
	self error: 'invalid input'! !

!JSJsonParser methodsFor: 'private' stamp: 'lr 6/25/2009 23:01'!
whitespace
	"Strip whitespaces from the input stream."

	[ stream atEnd not and: [ stream peek isSeparator ] ]
		whileTrue: [ stream next ]! !

WAObject subclass: #JSObject
	instanceVariableNames: 'decoration renderContext rendererClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

JSObject subclass: #JSLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSLogger commentStamp: 'lr 11/28/2006 10:40' prior: 0!
I am a logger class to be used together with FireBug. I have nothing to do with Scriptaculous directly, but I nicely fit in here as everybody should be using FireBug for Script debugging anyway.!

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assert: anObject 
	self 
		call: 'assert'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject equals: anotherObject 
	self 
		call: 'assertEquals'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:11'!
assert: anObject greater: anotherObject 
	self 
		call: 'assertGreater'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:11'!
assert: anObject less: anotherObject 
	self 
		call: 'assertLess'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:12'!
assert: anObject notEquals: anotherObject 
	self 
		call: 'assertNotEquals'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject notGreater: anotherObject 
	self 
		call: 'assertNotGreater'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject notLess: anotherObject 
	self 
		call: 'assertNotLess'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertFalse: anObject 
	self 
		call: 'assertFalse'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNotNull: anObject 
	self 
		call: 'assertNotNull'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNotUndefined: anObject 
	self 
		call: 'assertNotUndefined'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNull: anObject 
	self 
		call: 'assertNull'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertTrue: anObject 
	self 
		call: 'assertTrue'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertUndefined: anObject 
	self 
		call: 'assertUndefined'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
debug: anObject 
	self 
		call: 'debug'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
error: anObject 
	self 
		call: 'error'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
info: anObject 
	self 
		call: 'info'
		with: anObject! !

!JSLogger methodsFor: 'logging' stamp: 'lr 10/14/2008 09:10'!
log: anObject 
	self 
		call: 'log'
		with: anObject! !

!JSLogger methodsFor: 'logging' stamp: 'lr 10/14/2008 09:10'!
log: anObject format: anArray 
	self 
		call: 'log'
		withArguments: (Array with: anObject) , anArray! !

!JSLogger methodsFor: 'printing' stamp: 'lr 11/28/2006 10:13'!
printContentOn: aStream
	aStream nextPutAll: 'console'! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
warn: anObject 
	self 
		call: 'warn'
		with: anObject! !

!JSObject class methodsFor: 'instance creation' stamp: 'jf 7/19/2009 14:07'!
context: aRenderContext
	^ self new setContext: aRenderContext; yourself! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
& anObject 
	"Combine the receiver and anObject with a logical AND."
	
	self addDecoration: (JSBinary new operator: '&&'; statement: anObject)! !

!JSObject methodsFor: 'convenience' stamp: 'jf 7/19/2009 18:08'!
, anObject 
	"Concatenate the receiver with anObject."
	self addDecoration: (JSConcatenation on: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:42'!
access: aString 
	"Access the member aString."
	
	self addDecoration: (JSAccess named: aString)! !

!JSObject methodsFor: 'adding' stamp: 'lr 11/17/2008 20:15'!
addDecoration: aDecoration
	"Add a new decoration to the receiver."

	aDecoration setOwner: decoration.
	decoration := aDecoration! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:42'!
alias: aString 
	"Uses aString as an alias for the receiver."
	
	self addDecoration: (JSAlias named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:40'!
apply: aCollection 
	"Apply aCollection of arguments."
	
	self addDecoration: (JSApply new arguments: aCollection)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:40'!
assign: anObject 
	"Assign anObject to the receiver."
	
	self addDecoration: (JSAssignment new object: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
assignLocalTo: aString 
	"Assign the receiver to a local variable aString."
	
	self addDecoration: (JSAssignLocal named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
assignTo: aString 
	"Assign the receiver to a global variable aString."
	
	self addDecoration: (JSAssign named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString
	"Call the method named aString."

	self call: aString withArguments: #()! !

!JSObject methodsFor: 'deprecated' stamp: 'lr 4/24/2009 20:22'!
call: aString argument: anObject
	"Call the method named aString with anObject as its argument."

	self
		seasideDeprecatedApi: 'JSObject>>#call:argument:'
		details: 'Use #call:with:.'.
	self call: aString with: anObject! !

!JSObject methodsFor: 'deprecated' stamp: 'lr 4/24/2009 20:22'!
call: aString arguments: anArray
	"Call the method named aString with aCollection as its arguments."

	self 
		seasideDeprecatedApi: 'JSObject>>#call:arguments:'
		details: 'Use #call:withArguments:.'.
	self call: aString withArguments: anArray! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString with: anObject
	"Call the method named aString with anObject as its argument."

	self call: aString withArguments: (Array with: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString with: anObject1 with: anObject2
	"Call the method named aString with anObject1 and anObject2 as its arguments."

	self call: aString withArguments: (Array with: anObject1 with: anObject2)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString with: anObject1 with: anObject2 with: anObject3
	"Call the method named aString with anObject1 and anObject2 and anObject3 as its arguments."

	self call: aString withArguments: (Array with: anObject1 with: anObject2 with: anObject3)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString withArguments: anArray
	"Call the method named aString with anArray as arguments."

	self addDecoration: (JSCall new 
		name: aString;
		arguments: anArray;
		yourself)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
condition: anObject 
	"Treat anObject as a condition to the execution of the receiver."
	
	self addDecoration: (JSCondition on: anObject)! !

!JSObject methodsFor: 'convenience' stamp: 'lr 10/14/2008 12:19'!
confirm: anObject 
	"Show a confirmation with the message anObject before evaluating the receiver."
	
	self condition: (JSStream new
		nextPutAll: 'confirm';
		argument: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
create
	"Instantiate the receiver."
	
	self addDecoration: JSCreate new! !

!JSObject methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:14'!
decoration
	"Answer the top-level decoration in the receivers decoration stack."

	^ decoration! !

!JSObject methodsFor: 'initialization' stamp: 'lr 11/11/2008 22:57'!
initialize
	super initialize.
	decoration := self! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
interval: aDuration
	"Execute the receiver every aDuration."

	self addDecoration: (JSInterval duration: aDuration)! !

!JSObject methodsFor: 'testing' stamp: 'lr 12/4/2008 22:30'!
isJavascript
	^ true! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
not
	"Negate the receiver logically."
	
	self addDecoration: JSNegation new! !

!JSObject methodsFor: 'printing' stamp: 'lr 10/13/2008 21:17'!
printContentOn: aStream
	self subclassResponsibility! !

!JSObject methodsFor: 'printing' stamp: 'lr 10/13/2008 21:17'!
printOn: aStream
	self decoration printContentOn: aStream! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
property: aString 
	"Treat anObject as a condition to the execution of the receiver."
	
	self addDecoration: (JSProperty named: aString)! !

!JSObject methodsFor: 'utilities' stamp: 'lr 10/14/2008 21:48'!
render: aRenderable
	"Render aRenderable and answer the resulting string."
	
	^ String streamContents: [ :stream | self render: aRenderable on: stream ]! !

!JSObject methodsFor: 'utilities' stamp: 'jf 7/19/2009 17:23'!
render: aRenderable on: aStream
	"Render aRenderable on aStream."
	
	| document html |
	document := JSDocument on: aStream codec: self requestContext codec.
	document open.
	self renderContext document: document during: [
		html := self rendererClass context: self renderContext.
		html render: aRenderable; flush.
		document close ]! !

!JSObject methodsFor: 'accessing' stamp: 'jf 7/19/2009 13:57'!
renderContext
	"Answer the current RenderContext."

	^ renderContext! !

!JSObject methodsFor: 'accessing' stamp: 'jf 7/19/2009 18:23'!
rendererClass
	"Answer the class that should be used when rendering objects."

	^ rendererClass ifNil: [ rendererClass := WARenderer default ]! !

!JSObject methodsFor: 'accessing' stamp: 'jf 7/19/2009 17:21'!
rendererClass: aRendererClass
	"Specify the class that should be used when rendering objects."

	rendererClass := aRendererClass! !

!JSObject methodsFor: 'convenience' stamp: 'lr 10/14/2008 12:22'!
return: anObject 
	"Return anObject after evaluating the receiver."
	
	self , (JSStream new
		nextPutAll: 'return ';
		javascript: anObject)! !

!JSObject methodsFor: 'utilities' stamp: 'lr 10/14/2008 21:48'!
script: aBlock
	"Evaluate aBlock and answer the string of the generated script."
	
	^ String streamContents: [ :stream | self script: aBlock on: stream ]! !

!JSObject methodsFor: 'utilities' stamp: 'jf 7/19/2009 17:36'!
script: aBlock on: aStream
	"Evaluate aBlock and pass in a script object that is subsequently written to aStream."
	
	| script document |
	document := JSDocument on: aStream codec: self requestContext codec.
	document open.
	self renderContext document: document during: [ 
		script := (JSScript context: self renderContext)
			rendererClass: self rendererClass;
			yourself.
		aBlock value: script.
		script addAll: document loadScripts ].
	script printOn: aStream! !

!JSObject methodsFor: 'initialization' stamp: 'jf 7/19/2009 14:06'!
setContext: aRenderContext
	renderContext := aRenderContext! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:16'!
then: anObject
	"Evaluates anObject if the receiver treated as a boolean evaluates to true."

	self then: anObject else: nil! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
then: anObject else: anotherObject 
	"Evaluates anObject if the receiver treated as a boolean evaluates to true, otherwise evaluate anotherObject."
	
	self addDecoration: (JSIfThenElse new
		trueStatement: anObject;
		falseStatement: anotherObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
timeout: aDuration 
	"Evaluates the receiver after aDuration."
	
	self addDecoration: (JSTimeout duration: aDuration)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
| anObject 
	"Combine the receiver and anObject with a logical OR."
	
	self addDecoration: (JSBinary new operator: '||'; statement: anObject)! !

JSObject subclass: #JSScript
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSScript commentStamp: 'lr 4/28/2008 09:41' prior: 0!
I represent a sequence of JavaScript statements.!

JSScript subclass: #JSFunction
	instanceVariableNames: 'return arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSFunction commentStamp: 'lr 4/28/2008 09:40' prior: 0!
I represent an anonymous JavaScript function.!

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:57'!
argument
	^ arguments! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:55'!
arguments
	^ arguments! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:55'!
arguments: aCollection
	arguments := aCollection! !

!JSFunction methodsFor: 'converting' stamp: 'lr 5/17/2006 11:27'!
asFunction
	^ self! !

!JSFunction methodsFor: 'converting' stamp: 'lr 1/4/2007 17:22'!
asFunction: aCollection
	self arguments: aCollection! !

!JSFunction methodsFor: 'initialization' stamp: 'lr 1/4/2007 15:59'!
initialize
	super initialize.
	arguments := #()! !

!JSFunction methodsFor: 'printing' stamp: 'lr 2/19/2007 13:45'!
printContentOn: aStream
	aStream nextPutAll: 'function('.
	self arguments
		do: [ :each | aStream nextPutAll: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPutAll: '){'.
	statements isEmpty ifFalse: [
		statements allButLast
			do: [ :each | aStream javascript: each; nextPut: $; ].
		self return
			ifTrue: [ aStream nextPutAll: 'return ' ].
		aStream javascript: statements last ].
	aStream nextPut: $}! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 5/15/2006 11:04'!
return
	^ return ifNil: [ false ]! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 5/15/2006 11:04'!
return: aBoolean
	return := aBoolean! !

!JSScript methodsFor: 'adding' stamp: 'lr 8/29/2006 08:36'!
, anObject
	self add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 10/19/2008 19:10'!
<< anObject
	^ self add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 8/4/2006 08:59'!
add: anObject
	^ statements add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 12/3/2008 19:11'!
addAll: aCollection
	^ statements addAll: aCollection! !

!JSScript methodsFor: 'convenience' stamp: 'lr 10/13/2008 21:34'!
alert: anObject 
	self add: (JSStream new
		nextPutAll: 'alert';
		argument: anObject;
		yourself)! !

!JSScript methodsFor: 'convenience' stamp: 'jf 7/19/2009 14:16'!
callback: aBlock
	self goto: (self renderContext actionUrl
		withParameter: (self renderContext callbacks store: (WAActionCallback on: aBlock)))! !

!JSScript methodsFor: 'convenience' stamp: 'lr 9/8/2009 12:50'!
goto: aUrl 
	self add: (JSStream new
		nextPutAll: 'window.location=';
		javascript: aUrl)! !

!JSScript methodsFor: 'initialization' stamp: 'lr 5/10/2006 19:47'!
initialize
	super initialize.
	statements := OrderedCollection new! !

!JSScript methodsFor: 'convenience' stamp: 'jf 7/19/2009 17:35'!
logger
	^ self add:
		((JSLogger context: self renderContext)
			rendererClass: self rendererClass;
			yourself)! !

!JSScript methodsFor: 'printing' stamp: 'lr 2/19/2007 13:45'!
printContentOn: aStream
	statements
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $; ]! !

!JSScript methodsFor: 'convenience' stamp: 'jf 7/19/2009 13:57'!
refresh
	self goto: self renderContext actionUrl! !

JSObject subclass: #JSStream
	instanceVariableNames: 'stream'
	classVariableNames: 'Arguments JavascriptCharacters This'
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSStream commentStamp: 'lr 4/28/2008 09:44' prior: 0!
I represent a verbatim JavaScript string. I support streaming facilities to efficiently encode JavaScript input.!

JSStream subclass: #JSJsonStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSJsonStream commentStamp: 'pmm 8/30/2009 18:59' prior: 0!
I am a specialization of JSStream that conforms to the JSON spec (http://www.json.org).!

!JSJsonStream class methodsFor: 'encoding' stamp: 'pmm 8/30/2009 19:01'!
encodeKey: aKey on: aStream
	"Encode the key of a Key-value pair for JSON, try to optimize their serialization."
	
	 self encodeString: aKey seasideString on: aStream! !

!JSStream class methodsFor: 'instance creation' stamp: 'lr 10/16/2008 21:49'!
argument: anInteger
	^ (Arguments at: anInteger + 1) copy! !

!JSStream class methodsFor: 'instance creation' stamp: 'lr 10/16/2008 21:49'!
argumentAt: anInteger
	^ (Arguments at: anInteger) copy! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 2/12/2009 09:43'!
encodeArguments: aCollection on: aStream 
	"Writes aCollection of elements to aStream enclosed in round brakes and separated by a comma."
	
	aStream nextPut: $(.
	aCollection
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 2/12/2009 09:43'!
encodeCollection: aCollection on: aStream
	"Writes aCollection of elements to aStream enclosed in square brakets."
	
	aStream nextPut: $[.
	aCollection
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $]! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 2/12/2009 09:44'!
encodeDictionary: aDictionary on: aStream 
	"Dictionary or hash-maps common structures in JavaScript, try to optimize their serialization."
	
	| first |
	first := true.
	aStream nextPut: ${.
	aDictionary keysAndValuesDo: [ :key :value |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aStream nextPut: $, ].
		self encodeKey: key value: value on: aStream ].
	aStream nextPut: $}! !

!JSStream class methodsFor: 'encoding' stamp: 'pmm 8/30/2009 19:00'!
encodeKey: aKey on: aStream
	"Encode the key of a Key-value pair for JavaScript, try to optimize their serialization."
	
	(aKey isString and: [ aKey isEmpty not and: [ aKey first isLetter and: [ aKey allSatisfy: [ :each | each isAlphaNumeric ] ] ] ]) 
		ifTrue: [ aStream nextPutAll: aKey ]
		ifFalse: [ self encodeString: aKey seasideString on: aStream ]! !

!JSStream class methodsFor: 'encoding' stamp: 'pmm 8/30/2009 19:00'!
encodeKey: aKey value: aValue on: aStream 
	"Key-value pairs are common structures in JavaScript, try to optimize their serialization."
	
	self encodeKey: aKey on: aStream.
	aStream nextPut: $:; javascript: aValue! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 4/14/2009 00:19'!
encodeString: aString on: aStream
	"Strings have a complicated encoding in Javascript, try to optimize their serialization."

	| char value encoded |
	aStream nextPut: $".
	1 to: aString size do: [ :index |
		char := aString at: index.
		value := char seasideInteger.
		value < JavascriptCharacters size
			ifFalse: [ aStream nextPut: char ]
			ifTrue: [
				encoded := JavascriptCharacters at: value + 1.
				encoded isString
					ifTrue: [ aStream nextPutAll: encoded ]
					ifFalse: [ aStream nextPut: encoded ] ] ].
	aStream nextPut: $"! !

!JSStream class methodsFor: 'initialization' stamp: 'lr 10/14/2008 11:36'!
initialize
	self initializeEncoding.
	self initializeSnippets! !

!JSStream class methodsFor: 'initialization' stamp: 'lr 1/23/2009 11:59'!
initializeEncoding
	| printer escapes |
	printer := WANumberPrinter new.
	printer base: 16; padding: $0; digits: 2.
	JavascriptCharacters := Array new: 127.
	0 to: 31 do: [ :each |
		JavascriptCharacters
			at: each + 1
			put: '\x' , (printer print: each) ].
	32 to: 126 do: [ :each |
		JavascriptCharacters
			at: each + 1
			put: each asCharacter ].
	escapes := #( 0 '\0' 7 '\a' 8 '\b' 9 '\t' 10 '\n' 12 '\f' 13 '\r' 34 '\"' 92 '\\' ).
	1 to: escapes size - 1 by: 2 do: [ :index |
		JavascriptCharacters
			at: (escapes at: index) + 1
			put: (escapes at: index + 1) ]! !

!JSStream class methodsFor: 'initialization' stamp: 'lr 10/14/2008 11:36'!
initializeSnippets
	This := self on: 'this'.
	Arguments := (0 to: 25)
		collect: [ :each | self on: 'arguments[' , each printString , ']' ]! !

!JSStream class methodsFor: 'instance creation' stamp: 'lr 5/10/2006 20:36'!
on: aString
	^ self new nextPutAll: aString! !

!JSStream class methodsFor: 'instance creation' stamp: 'lr 10/14/2008 11:45'!
this
	^ This copy! !

!JSStream methodsFor: 'convenience' stamp: 'lr 2/12/2009 09:56'!
argument: anObject
	"Write a single argument anObject onto the receiving stream."

	self arguments: (Array with: anObject)! !

!JSStream methodsFor: 'convenience' stamp: 'lr 2/12/2009 09:57'!
arguments: aCollection
	"Write aCollection of arguments onto the stream."

	self class encodeArguments: aCollection on: self! !

!JSStream methodsFor: 'accessing' stamp: 'lr 5/1/2006 17:06'!
contents
	^ self stream contents! !

!JSStream methodsFor: 'copying' stamp: 'lr 5/10/2006 20:36'!
copy
	^ self class on: self contents! !

!JSStream methodsFor: 'initialization' stamp: 'lr 2/4/2009 08:02'!
initialize
	super initialize.
	stream := WriteStream on: String new! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
javascript: anObject
	self stream javascript: anObject! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
nextPut: aCharacter
	self stream nextPut: aCharacter! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
nextPutAll: aString
	self stream nextPutAll: aString! !

!JSStream methodsFor: 'printing' stamp: 'lr 4/28/2008 10:00'!
printContentOn: aStream
	aStream nextPutAll: self contents! !

!JSStream methodsFor: 'accessing' stamp: 'lr 5/1/2006 17:06'!
stream
	^ stream! !

!String methodsFor: '*javascript-core' stamp: 'lr 10/14/2008 00:37'!
asFunction: aCollection
	^ (JSStream on: self) asFunction: aCollection! !

!String methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:45'!
javascriptOn: aStream
	JSStream encodeString: self on: aStream! !

!WAPackage class methodsFor: '*javascript-core' stamp: 'jf 7/19/2009 18:50'!
javascriptCore
	^ self new
		name: 'Javascript-Core';
		description: 'Javascript integration in Seaside. Provides a basic functionality to generate Javascript from Smalltalk.';
		addDependency: 'Seaside-Core';
		yourself! !

!Stream methodsFor: '*javascript-core' stamp: 'lr 5/10/2006 20:31'!
arguments: aCollection
	self nextPut: $(.
	aCollection
		do: [ :each | self javascript: each ]
		separatedBy: [ self nextPut: $, ].
	self nextPut: $)! !

!Stream methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:45'!
javascript: anObject
	anObject javascriptOn: self! !

!DateAndTime methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:05'!
javascriptMonthIndex
	^ self monthIndex - 1! !

!DateAndTime methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:05'!
javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth hour minute second )
		do: [ :each | aStream print: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

!Object methodsFor: '*javascript-core' stamp: 'lr 1/4/2007 17:20'!
asFunction
	^ self asFunction: #()! !

!Object methodsFor: '*javascript-core' stamp: 'lr 10/14/2008 00:37'!
asFunction: aCollection
	^ JSFunction new add: self; arguments: aCollection! !

!Object methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:49'!
asJavascript
	^ String streamContents: [ :stream | self javascriptOn: stream ]! !

!Object methodsFor: '*javascript-core' stamp: 'lr 12/4/2008 22:30'!
isJavascript
	^ false! !

!Object methodsFor: '*javascript-core' stamp: 'lr 4/20/2006 21:10'!
javascriptOn: aStream
	self printOn: aStream! !

!WATagBrush methodsFor: '*javascript-core' stamp: 'lr 1/23/2009 07:58'!
passenger: anObject
	"Assign a passenger object to the receiver. This is used to keep a mapping between DOM elements and Smalltalk objects. Note, that to we are required to assign a numeric id to the reciever in order to keep the mapping between DOM element and Smalltalk object."

	canvas callbacks registerPassenger: anObject named: self ensureId! !

!WATagBrush methodsFor: '*javascript-core' stamp: 'jf 1/22/2009 22:44'!
script: anObject
	"Attach a JavaScript object to the receiver. The argument automatically knows the ID of the DOM element it should operate on and will be evaluated when the page complete loading."

	anObject isNil 
		ifTrue: [ ^ self ].
	(anObject respondsTo: #id:)
		ifTrue: [ anObject id: self ensureId ].
	canvas document addLoadScript: anObject! !

WACallback subclass: #JSAjaxCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSAjaxCallback methodsFor: 'accessing' stamp: 'lr 12/6/2008 20:54'!
block: aZeroOrOneArgBlock
	block := aZeroOrOneArgBlock isNil
		ifFalse: [ aZeroOrOneArgBlock fixCallbackTemps ]! !

!JSAjaxCallback methodsFor: 'evaluation' stamp: 'lr 5/20/2009 19:58'!
evaluateWithArgument: anObject
	block isNil
		ifFalse: [ block valueWithPossibleArguments: (Array with: anObject) ].
	self requestContext
		respond: [ :response | response doNotCache ]! !

!JSAjaxCallback methodsFor: 'accessing' stamp: 'lr 12/28/2008 14:49'!
priority
	^ 5! !

WACallback subclass: #JSPassenger
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSPassenger methodsFor: 'evaluation' stamp: 'lr 10/21/2008 16:07'!
evaluateWithArgument: anObject
	self shouldNotImplement! !

!JSPassenger methodsFor: 'testing' stamp: 'lr 2/15/2009 16:56'!
isEnabledFor: aRequestContext
	^ false! !

!JSPassenger methodsFor: 'testing' stamp: 'lr 10/21/2008 16:15'!
isPassenger
	^ true! !

!JSPassenger methodsFor: 'accessing' stamp: 'lr 10/21/2008 16:08'!
object
	^ object! !

!JSPassenger methodsFor: 'initialization' stamp: 'lr 10/21/2008 16:09'!
setObject: anObject
	object := anObject! !

!WACallback methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:16'!
isPassenger
	^ false! !

!UndefinedObject methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:44'!
javascriptOn: aStream
	aStream nextPutAll: 'null'! !

!WARenderer methodsFor: '*javascript-core' stamp: 'jf 7/19/2009 18:44'!
javascript
	^ (JSScript context: self context)
		rendererClass: self species;
		yourself! !

!WARenderer methodsFor: '*javascript-core' stamp: 'jf 7/19/2009 18:44'!
logger
	^ (JSLogger context: self context)
		rendererClass: self species;
		yourself! !

!Date methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:04'!
javascriptMonthIndex
	^ self monthIndex - 1! !

!Date methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:04'!
javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth )
		do: [ :each | aStream print: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

WAError subclass: #JSJsonSyntaxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Parser'!

!JSJsonSyntaxError commentStamp: 'pmm 12/15/2008 19:45' prior: 0!
A JSJsonSyntaxError signals invalid JSON input.
!

!Dictionary methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:44'!
javascriptOn: aStream
	JSStream encodeDictionary: self on: aStream! !

!Association methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:44'!
javascriptOn: aStream
	JSStream encodeKey: self key value: self value on: aStream! !

!Collection methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:43'!
javascriptOn: aStream
	JSStream encodeCollection: self on: aStream! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:39'!
passengerAt: aString
	^ self passengerAt: aString ifAbsent: [ nil ]! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 12/28/2008 16:33'!
passengerAt: aString ifAbsent: aBlock
	| passenger |
	passenger := callbacks at: aString ifAbsent: [ ^ aBlock value ].
	passenger isPassenger ifFalse: [ ^ aBlock value ].
	^ passenger object! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'MAD 2/20/2009 15:14'!
registerAjaxCallback: aBlock 
	self
		seasideDeprecatedApi: 'WACallbackRegistry>>#registerAjaxCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (JSAjaxCallback on: aBlock)! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 1/23/2009 08:01'!
registerPassenger: anObject named: aString
	| callback |
	callback := JSPassenger new.
	callback setKey: aString callbacks: callbacks; setObject: anObject.
	callbacks at: (callback convertKey: aString) put: callback.
	^ aString! !

WAHtmlDocument subclass: #JSDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSDocument commentStamp: 'lr 4/28/2008 09:47' prior: 0!
I represent a document that is sent back when processing an AJAX request. I am an internal class.!

!JSDocument methodsFor: 'load scripts' stamp: 'jf 1/23/2009 03:30'!
wrapLoadScripts: aBlock
	self nextPutAll: '/*<!![CDATA[*/'.
	aBlock value.
	self nextPutAll: '/*]]>*/'! !

!JSDocument methodsFor: 'load scripts' stamp: 'jf 1/23/2009 13:10'!
writeLoadScripts
	loadScripts isEmpty ifFalse: [ super writeLoadScripts ]! !

!WASmallDictionary methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:44'!
javascriptOn: aStream
	JSStream encodeDictionary: self on: aStream! !

!Duration methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:56'!
javascriptOn: aStream
	aStream javascript: self asMilliSeconds! !

!Character methodsFor: '*javascript-core' stamp: 'lr 7/12/2006 12:09'!
javascriptOn: aStream
	(String with: self) javascriptOn: aStream! !
JSStream initialize!
